;ͻ
;                                                                          
;                    Copyright (c) 1995 Aldo Ferraro                       
;                          All Rights Reserved                             
;                                                                          
;Ķ
;                                                                          
;  Filename      :  DAC.ASM                         Version : 1.0          
;                                                                          
;  Program Title :  DAC Procedures                                         
;                                                                          
;  Description   :  DAC read/write operations                              
;                                                                          
;  Author Name   :  Aldo Ferraro                                           
;                                                                          
;  Language      :  Turbo Assembler version 3.1 using MASM Mode            
;                                                                          
;  Command Line  :  TASM  DAC.ASM /m2 /q                                   
;                                                                          
;ͼ

	%TITLE	"DAC Procedures"
	PAGE	58, 132

;ͻ
;                   Set memory model and instruction set                   
;ͼ

	.MODEL 	large
	.386P
	.387

;ͻ
;                              Public Names                                
;ͼ


;ͻ
;                            Public Procedures                             
;ͼ

	PUBLIC	clr_dac    			; clear DAC RGB colour block
	PUBLIC	set_dac				; set DAC RGB colour

;ͻ
;                               Code Segment                               
;ͼ

	.CODE

;ͻ
;                        Clear DAC RGB Colour Block                        
;Ķ
;                                                                          
; Description :  Clear DAC RGB colour block                                
;                                                                          
; On Entry    :  bx = start of DAC RGB colour block to clear               
;                cx = number of colours in palette to clear                
;                                                                          
; Returns     :  none                                                      
;                                                                          
;ͼ

clr_dac    	proc

	cli 					; disable interrupts
	mov	dx,3C8h                 	; DAC write register 3C8h

clr_rgb:

	mov	ax,bx                   	; get colour entry request
	out	dx,al                   	; set colour request
	inc	dx				; DAC data register 3C9h
	xor	ax,ax                   	; use zero values
	out	dx,al             		; set red composite
	out	dx,al             		; set green composite
	out	dx,al             		; set blue composite
	dec	dx				; DAC write register 3C8h
	inc	bx                      	; get next colour in block
	loop	clr_rgb                 	; loop back for number count
	sti					; enable interrupts
	ret

clr_dac    	endp

;ͻ
;                            Set DAC RGB Colour                            
;Ķ
;                                                                          
; Description :  Define DAC RGB colour                                     
;                                                                          
; On Entry    :  eax = DAC colour entry and RGB composites                 
;                                                                          
;                      eax = blue : green : red : colour                   
;                                                                          
; Returns     :  none                                                      
;                                                                          
;ͼ

set_dac		proc

	cli 					; disable interrupts
	mov	dx,3C8h                 	; DAC write register 3C8h
	out	dx,al				; set colour request
	inc	dx				; DAC data register 3C9h
	shr	eax,8				; get red composite request
	out	dx,al                   	; set red composite
	shr	eax,8                   	; get green composite request
	out	dx,al                   	; set green composite
	shr	eax,8                   	; get blue composite request
	out	dx,al                   	; set blue composite
	sti					; enable interrupts
	ret

set_dac		endp

;ͻ
;                            End of Assembly                               
;ͼ

	END

